/*****************************************************************
 *  OLEDCu@@SSD1331p
 *
 ****************************************************************/
#include "OLED_lib.h"
#include "font_level1_lib.h"
/********************************
* R}hAf[^o͊֐(SPI)
*********************************/
void spi_cmd(uint8_t cmnd){
    uint8_t cbuf[2];
    cbuf[0] = cmnd;
    DC_Clear();             // RS Command 
    CS_Clear();				// CS Low
    SERCOM3_SPI_Write(cbuf, 1);
    DC_Set();				// CD High
    CS_Set();				// CS High
}
void spi_data(uint8_t data){
    uint8_t dbuf[2];
    dbuf[0] = data;    
    DC_Set();				// RS Data
    CS_Clear();				// CS Low
    SERCOM3_SPI_Write(dbuf, 1);
    CS_Set();				// CS High
}
void spi_data2(uint8_t data1, uint8_t data2){
    uint8_t dbuf[2];
    dbuf[0] = data1;
    dbuf[1] = data2;
    DC_Set();
    CS_Clear();
    SERCOM3_SPI_Write(dbuf, 2);
    CS_Set();
}
/****************************
* OLED֐  
*****************************/
void OLED_Init(void){
    RES_Clear();
    Delay_ms(10);
    RES_Set();
    Delay_ms(500);
    spi_cmd(0xA4);          // Normal Display Mode
    spi_cmd(0xAF);          // Set Display On
    spi_cmd(0xA0);          // Set Color depth 
    spi_cmd(0b00100000);    // ォE֕\ 256F
    spi_cmd(0xB0);          // Powersave mode
    spi_cmd(0x0B);          // No:Disable
    // Set Window Frame
    spi_cmd(0x15);          // Column Window Set
    spi_cmd(0);             // Start
    spi_cmd(95);            // End
    spi_cmd(0x75);          // Row Window Set
    spi_cmd(0);             // Start
    spi_cmd(63);            // End
    // Set Contrast
    spi_cmd(0x81);          // Color A
    spi_cmd(0xFF);
    spi_cmd(0x82);          // Color B
    spi_cmd(0xFF);
    spi_cmd(0x83);          // Color C
    spi_cmd(0xFF);
}
/*********************************
 * SʎwFŏ
 *********************************/
void OLED_Clear(uint8_t color){
    uint16_t i;
    // Set Window Frame
    spi_cmd(0x15);          // Column Window Set
    spi_cmd(0);             // Start
    spi_cmd(95);            // End
    spi_cmd(0x75);          // Row Window Set
    spi_cmd(0);             // Start
    spi_cmd(63);            // End
    for(i=0; i<=(96*64); i++)
        spi_data(color);
}
/************************************
 * 1sNZ\֐
 * W(0,0)(95,63)
 ***********************************/
void OLED_Pixel(uint8_t Xpos, uint8_t Ypos, uint8_t color){
    // Set Window Frame
    spi_cmd(0x15);          // Column Window Set
    spi_cmd(Xpos);          // Start
    spi_cmd(Xpos);          // End
    spi_cmd(0x75);          // Row Window Set
    spi_cmd(Ypos);          // Start
    spi_cmd(Ypos);          // End
    spi_data(color);        // Write    
}
/*****************************************
*  ANK\֐ 6x9hbg
*  96/6=16/s@64/9=7s
*  (0, 0) - (11, 7)͈̔
******************************************/
void OLED_Char(uint8_t colum, uint8_t line, const uint8_t letter, uint8_t Color1, uint8_t Color2){
    uint8_t j, i, Mask;

    for(j=0; j<5; j++){                                     // 5hbg
        OLED_Pixel(colum*6+j, (line+1)*9-8, Color2);        // ŏ㗓
        Mask = 0x80;                                        // ʃrbg\
        for(i=0; i<8; i++){                                 // c1C\         
            if((Font[letter-0x20][j] & Mask) != 0)
                OLED_Pixel(colum*6+j, (line+1)*9-i, Color1);
            else
                OLED_Pixel(colum*6+j, (line+1)*9-i, Color2); //wiF
            Mask = Mask >> 1;
        }
    }
    for(j=5; j<6; j++){                                     // 3hbguN
        for(i=0; i<9; i++)
            OLED_Pixel(colum*6+j, (line+1)*9-i, Color2);      //wiF         
    }
}
/*****************************************
*  ASCII\֐ 12x12hbg
*  96/12=8/s@64/14=4s
*  (0, 0) - (7, 4)͈̔, FAwiF
******************************************/
void OLED_xChar(uint8_t colum, uint8_t line, uint8_t letter, uint8_t Color1, uint8_t Color2){
    uint8_t j, i, Mask;

    // ANK\ó@3oCg2C6JԂ
    for(j=0; j<6; j++){
        // 8hbgA̕\
        Mask = 0x80;
        for(i=0; i<8; i++){
            // PCڑO8hbg\
            if((ANKFont[letter][j*3] & Mask) != 0)
                OLED_Pixel(colum*12+i, line*13+j*2, Color1);
            else
                OLED_Pixel(colum*12+i, line*13+j*2, Color2); 	//wiF
            // 2Cڌ㔼8hbg\
            if((ANKFont[letter][j*3+2] & Mask) != 0)
                OLED_Pixel(colum*12+i+4, line*13+j*2+1, Color1);
            else
                OLED_Pixel(colum*12+i+4, line*13+j*2+1, Color2); 	//wiF
            Mask = Mask >> 1;
        }
        // 4hbg\
        Mask = 0x80;
        // 1Cڌ㔼4hbg\
        for(i=0; i<4; i++){
            if((ANKFont[letter][j*3+1] & Mask) != 0)
                OLED_Pixel(colum*12+i+8, line*13+j*2, Color1);
            else
                OLED_Pixel(colum*12+i+8, line*13+j*2, Color2);	 //wiF
            Mask = Mask >> 1;
        }
        // 2CڑO4hbg\
        for(i=4; i<8; i++){
            if((ANKFont[letter][j*3+1] & Mask) != 0)
                OLED_Pixel(colum*12+i-4, line*13+j*2+1, Color1);
            else
                OLED_Pixel(colum*12+i-4, line*13+j*2+1, Color2); 	//wiF
            Mask = Mask >> 1;
        }							
    }
}
/******************************
*   12x12`֐
*   85sŎw
******************************/
void OLED_xStr(uint8_t colum, uint8_t line, const uint8_t *s, uint8_t Color1, uint8_t Color2)
{
    while (*s != 0){
        OLED_xChar(colum++, line, *s++, Color1, Color2);
        if(colum >= 8){     // sI
            line++;         // ̍s
            colum = 0;      // s̐擪
            if(line >= 5)   // ŏIs
                line = 0;   // 擪s
        }
    }
}
/******************************
*   6x9`֐
*   167sŎw
******************************/
void OLED_Str(uint8_t colum, uint8_t line, const uint8_t *s, uint8_t Color1, uint8_t Color2)
{
    while (*s != 0){
        OLED_Char(colum++, line, *s++, Color1, Color2);
        if(colum >= 16){        // s
            line++;             // ̍s
            colum = 0;          // s̐擪
            if(line >= 7)       //@ŏIs
                line = 0;       // 擪s
        }
    }
}
/*******************************************
* \@R[hwŕ\
* @2oCgR[hŎw@12x12hbg
*  ShiftJISR[h 
*******************************************/
void KanjiCode(uint8_t colum, uint8_t line, uint16_t upcode, uint16_t lowcode, uint16_t Color1, uint16_t Color2)
{
	uint16_t upper, lower, i, j;
    uint8_t Mask;
	// R[hzCfbNXvZ
    upper = (upcode -0x81)*188;				// xxFC-xx40+1-1(7F)
    if(lowcode < 0x7F)						// R[h7F̓XLbv
        lower = (lowcode - 0x40);
    else
        lower = (lowcode - 0x41);			// 7FR[h1
    // \ó@3oCg2C6JԂ
    for(j=0; j<6; j++){
        // 8hbgA̕\
        Mask = 0x80;
        for(i=0; i<8; i++){
            // PCڑO8hbg\
            if((KanjiFont12b[upper+lower][j*3] & Mask) != 0)
                OLED_Pixel(colum*12+i, line*13+j*2, Color1);
            else
                OLED_Pixel(colum*12+i, line*13+j*2, Color2); //wiF
            // 2Cڌ㔼8hbg\
            if((KanjiFont12b[upper+lower][j*3+2] & Mask) != 0)
                OLED_Pixel(colum*12+i+4, line*13+j*2+1, Color1);
            else
                OLED_Pixel(colum*12+i+4, line*13+j*2+1, Color2); //wiF
            Mask = Mask >> 1;
        }
        // 4hbg\
        Mask = 0x80;
        // 1Cڌ㔼4hbg\
        for(i=0; i<4; i++){
            if((KanjiFont12b[upper+lower][j*3+1] & Mask) != 0)
                OLED_Pixel(colum*12+i+8, line*13+j*2, Color1);
            else
                OLED_Pixel(colum*12+i+8, line*13+j*2, Color2); //wiF
            Mask = Mask >> 1;
        }
        // 2CڑO4hbg\
        for(i=4; i<8; i++){
            if((KanjiFont12b[upper+lower][j*3+1] & Mask) != 0)
                OLED_Pixel(colum*12+i-4, line*13+j*2+1, Color1);
            else
                OLED_Pixel(colum*12+i-4, line*13+j*2+1, Color2); //wiF
            Mask = Mask >> 1;
        }							
    }
}	
/*********************************************************
* \
*  12x12hbg@@8@5s
*********************************************************/
void Kanji_Str(uint8_t colum, uint8_t line, const uint8_t *Msg, uint16_t Color1, uint16_t Color2)
{
    const uint8_t *ptr;
    
    ptr = Msg;
	while(*ptr != 0){	  
			KanjiCode(colum++, line, (uint16_t)*ptr, (uint16_t)*(ptr+1), Color1, Color2);
            ptr += 2;
			if(colum >= 8){         // s
				line++;             // ̍s
				colum = 0;          // s̐擪
				if(line >= 5)       // ŏIs
					line = 0;       // 擪s
			}
		}
}

